{ Programmname: CONFIG.PAS   }
{ (C)  Everts & Hagedorn     }
{      DOS International     }

{ Autor: Michael Holin

  Das Programm NICHT aus der
  Entwicklungsumgebung von
  Turbo Pascal heraus starten,
  sondern als EXE-Datei auf
  eine Diskette oder Festplatte
  compilieren!
}

{$I-,R-,D-}
uses dos;

const ver='PC-Config V2.25  '+
          '(C) DOS International  '+
          'Autor: Michael Holin';
      Int_Nr=$50;
 {Unbelegter Interrupt, der verbogen wird}
      timer=0;
      zykl=838;                 {ns/Zyklus}
      zyklinv=1193033;         {1/838.2 ns}
      x:array [0..1] of string[4]=
        ('Nein','Ja  ');


var regs:registers;
    ax,buff,faktor,NullWert,PuffSeg,
    printB,printD,VideoWaits:word;
    i,drive:integer;
    kapa,sektoren,old,scroll,
    VideoDurchS,takt:longint;
    platte,kontrol,tport,tstart,tstop:byte;
    AT,EGA,VGA,cache,BUS16:boolean;
    testherc:  word absolute $B700:0;
    ID:        byte absolute $F000:$FFFE;
    ram:       word absolute 0:$413;
    konfig:    word absolute 0:$410;
    VideoMode: byte absolute 0:$449;
    zeit:      word absolute 0:$46C;
    VideoInfo: byte absolute 0:$487;
    PS2:       word absolute 0:$40E;
    Kombi:     byte absolute 0:$48F;

procedure StartTimer;
begin
 {Setzt Timer auf 65535
  Dieser wird nun alle 838 ns um
  eins verringert}
  inline($FA);
  port[kontrol]:=tstart;
  port[tport]:=$FF;
  port[tport]:=$FF;
end;

function ReadTimer:word;
begin
  port[kontrol]:=tstop;
  ReadTimer:=65535-port[tport] shl 8
            -port[tport];
  inline($FB);
end;

procedure TestVideoSpeed;
 {testet Geschw. des Bildschirms}
var i:word;
    source:longint absolute 0:0;
    Mdest:longint absolute $B000:0;
    Cdest:longint absolute $B800:0;
    NW,Screenbase:word;
begin
  StartTimer;
  NW:=ReadTimer;
  if VideoMode=7 then begin
 {VideoRAM-Durchsatz bestimmen}
 {fr Monochrom}
     StartTimer;
     for i:=1 to 100 do begin
       Mdest:=source; Mdest:=source;
       Mdest:=source; Mdest:=source;
 {400 Langworte ins Video-RAM schreiben}
 {--> 800 Zeichen inkl. Attribut       }
     end;
     VideoDurchS:=ReadTimer-NW;
     Screenbase:=$B000;
     end
  else begin
 {fr Farbe}
     StartTimer;
     for i:=1 to 100 do begin
       Cdest:=source; Cdest:=source;
       Cdest:=source; Cdest:=source;
     end;
     VideoDurchS:=ReadTimer-NW;
     Screenbase:=$B800;
  end;
  VideoDurchS:=zyklinv div VideoDurchS
              * 800 div 1024;
  regs.ah:=37;
  regs.al:=Int_Nr;
 {Interrupt auf Screen umbiegen}
  regs.ds:=Screenbase;
  regs.dx:=0;
  msdos(regs);
  mem[Screenbase:0]:=$CF;     { $CF = IRET}
  StartTimer;
  intr(Int_Nr,regs);
  nullwert:=ReadTimer;
 {Zeit fr IRET messen}
  for i:=0 to 4000 do
    mem[Screenbase:i]:=$90;
 {Screen mit NOPs fllen}
  mem[Screenbase:4000]:=$CF;
  starttimer;
  intr(Int_Nr,regs);
 {NOPs ausfhren}
  VideoWaits:=readtimer-NullWert;
  StartTimer;
 {6 Zeichen ber INT 16 ausgeben}
  inline($b8/$20/$0e/$cd/$10/$b8/$20/$0e/
         $cd/$10/$b8/$20/$0e/$cd/$10/$b8/
         $20/$0e/$cd/$10/$b8/$20/$0e/$cd/
         $10/$b8/$20/$0e/$cd/$10);
  printB:=ReadTimer-NW;
  printB:=printB div 6;
 {Anzahl der Zyklen (838.2 ns)}
  StartTimer;
 {Zeichenausgabe ber DOS}
  write('         ');            {9 Spaces}
  printD:=(ReadTimer-NW) div 9;
  for i:=1 to 25 do writeln;
  StartTimer;
 {Eine Zeile scrollen ber INT 16}
  inline($b8/$0a/$0e/$cd/$10);
  scroll:=ReadTimer-NW;
  regs.ah:=0;
  regs.al:=videomode;
  intr(16,regs);
 {Bildschirm lschen}
end;

procedure TestEMS;
 {Bestimmt Expanded Memory}
var i:byte;
    ems:boolean;
    emsname,intname:string[8];
begin

 {Segment ermitteln, auf den der
  Interrupt-Vektor 67hex zeigt  }
  regs.ah:=$35;
  regs.al:=$67;
  msdos(regs);
  emsname:='EMMXXXX0';
 {Steht dieser String im Segment ES ab
  Byte 10, dann ist der EMS-Manager
  installiert                          }
  intname:='';
  for i:=0 to 7 do
    intname:=intname+
             chr(mem[regs.es:10+i]);
  ems:=(emsname=intname);
  if ems then begin
    write('Expanded Memory V');
    regs.ah:=$46;
 {Versionsnummer bestimmen}
    intr($67,regs);
    write(char(regs.al shr 4+48),
          '.',char(regs.al and 15+48),
          ' ......: ');
    regs.ah:=$42;
    intr($67,regs);
 {Gesamtanzahl der Seiten bestimmen}
    writeln(regs.dx*16,
         ' KByte, davon sind noch frei: ',
         regs.bx*16,' KByte');
  end;
end;

procedure TestEGABus;
 {EGA/VGA mit 8- oder 16-Bit-Bus?}
var i,loop,z1,z2:word;
    even: longint absolute $a000:0;
    odd : longint absolute $a000:1;
begin
    loop:=faktor div 5;
    StartTimer;
     for i:=1 to loop do begin
       even:=even; even:=even;
       even:=even; even:=even;
     end;
    z1:=ReadTimer;
    StartTimer;
     for i:=1 to loop do begin
       odd:=odd; odd:=odd;
       odd:=odd; odd:=odd;
     end;
    z2:=ReadTimer;
 {Differenz ? Ja: 16 Bit; Nein: 8 Bit}
    if z1+10<z2 then write('16-Bit-Bus, ')
                else write('8-Bit-Bus, ');
    if z1+10<z2 then BUS16:=true;
end;

procedure Search;
 {sucht nach BIOS-Erweiterungen}
var segment:word;
    i,lo,hi:byte;
    b:array [1..4] of byte;
begin
  segment:=$C000;
  hi:=0;
  while segment<$e100 do begin
    if memw[segment:0]=$AA55 then begin
      lo:=segment and 255;
      hi:=segment shr 8;
      b[4]:=lo and 15; b[3]:=lo shr 4;
      b[2]:=hi and 15; b[1]:=hi shr 4;
      for i:=1 to 4 do if b[i]<10 then
        write(chr(b[i]+48))
      else write(chr(b[i]+55));
      write('hex ');
    end;
    inc(segment,$100);
  end;
  if hi=0 then write(#13) else writeln;
end;

procedure BIOSID;
 {Sucht Copyright-Meldung im BIOS}
var i,j:word;
    bios:array[0..32768] of byte
         absolute $F000:$8000;
begin
  j:=0;
  if AT then i:=0 else i:=16384;
  repeat
    if (bios[i]=40) and
       (bios[i+2]=41) then begin
 { ( ) suchen }
       if (bios[i+1]=99) or
          (bios[i+1]=67) then begin
 { (c) oder (C) ? }
          repeat
            write(chr(bios[i]));
            inc(i);
            inc(j);
          until (bios[i]<14) or (j>50) or
                (bios[i]=46) or
                ((bios[i]=32) and
                (bios[i+1]=32));
          i:=32767;
       end;
    end;
    inc(i);
  until i=32768;
  writeln;
end;

procedure Festpl(Funktion,Spur,
                 Sek,Anz,Messung:byte;
                 var Zeit:word);
begin
  regs.ah:=Funktion;
  regs.dl:=$80+drive;            {Laufwerk}
  regs.dh:=0;                     {Kopfnr.}
  regs.ch:=Spur;                  {Spurnr.}
  regs.cl:=Sek;                 {Sektornr.}
  regs.al:=Anz;           {Anzahl Sektoren}
  regs.es:=PuffSeg;   {Segment des Puffers}
  regs.bx:=0;          {Offset des Puffers}
  if messung=1 then StartTimer;
  intr(19,regs);
  if messung=1 then
    Zeit:=ReadTimer-nullwert;
end;

procedure InterLeave;
 {Bestimmt Datendurchsatz der Festplatte}
var i,sek,last:word;
    lastd,durchs,max:longint;
begin
  write('Maximaler Daten-Durchsatz..: ');
  Festpl(2,10,1,1,0,i);
  i:=0;
  for sek:=4 to 50 do begin
 {max. 50 Sektoren auf einmal lesen}
    lastd:=durchs;
    last:=i;
    Festpl(2,10,1,sek,1,i);
    if regs.ah<>0 then begin
       writeln('kann nicht bestimmt '+
               'werden! Fehler: ',regs.ah);
       halt;
    end;
    durchs:=1;
    max:=512*60*sektoren;
 {maximaler Durchsatz in Byte/s}
    durchs:=durchs*zyklinv*512 div i*sek;
    if ((i+2000<last) and not (sek<6)) or
       (sek=50) then begin
       write(lastd div 1024,
             ' KByte/s  ==>  ');
       sek:=50; i:=0;
       repeat
         inc(i);
         old:=(max div i)-15;
       until (lastd>old);
       max:=0;
       if i<2 then i:=2;
       writeln('Wahrsch. Interleave: ',
               i-1);
    end;
  end;
end;

procedure Access(zyl:word);
 {ermittelt Zugriffszeit der Festpatte}
var i,Spur,z1,z2,dummy:word;
begin
  write('Durchschnittl. Zugriffszeit: ');
  randomize;
  kapa:=zeit;
  for i:=0 to 99 do begin
    write(99-i:2,#8,#8);
    Spur:=random(zyl);
    Festpl(12,Spur and 255,(Spur and 768)
           shr 2+1,1,0,dummy);
    if regs.ah<>0 then begin
       writeln('kann nicht bestimmt '+
               'werden! Fehler: ',regs.ah);
       halt;
    end;
  end;
  kapa:=zeit-kapa;
  write(kapa *10 div 18,' ms');
  kapa:=0;
  Festpl(12,1,1,1,0,dummy);
  for Spur:=1 to 50 do begin
 {Bestimme Spur-zu-Spur-Zeit}
    Festpl(12,Spur,1,1,1,z1);
    inc(kapa,z1);
  end;
  kapa:=kapa div 5000*zykl div 10000;
  writeln(',  Spur zu Spur: ',kapa,' ms');
  Spur:=random(255);
  for i:=1 to 2 do begin
 {Teste auf Cache-Programm}
    Festpl(2,Spur,1,1,1,dummy);
    z2:=z1;
    Festpl(2,Spur+1,1,1,1,z1);
  end;
  if z2+700-z1>7000 then cache:=true;
end;


procedure TestCPU;
 {ermittelt Prozessor, Geschw., Takt
  und Waitstates}
var i,j,loop,z1,z2:word;
    ergeb:longint;
    even:longint absolute $1000:0;
    odd :longint absolute $1000:1;
    garp:longint absolute $1000:3;
    bus,buszyklus,AAMtime:byte;
    NEC,I386,BUS32:boolean;
begin
  regs.ah:=37;
  regs.al:=Int_Nr;
 {Interrupt auf Puffer umbiegen}
  regs.ds:=PuffSeg;
  regs.dx:=0;
  msdos(regs);
  mem[PuffSeg:0]:=$CF;        { $CF = IRET}
  StartTimer;
  intr(Int_Nr,regs);
  NullWert:=ReadTimer;
 {Zeit fr IRET messen}
  NEC:=false;
  I386:=false;
  BUS32:=false;
  if AT then begin
    loop:=150;
    ergeb:=3820000;
    buszyklus:=2;
    end
  else begin
    loop:=25;
    ergeb:=667000;
    buszyklus:=4;
  end;
  StartTimer;
 {die hoffentlich
  reprsentative Zeitschleife}
  for i:=0 to loop do begin
    j:=mem[i:i]+(regs.ah shl 3)-
       succ(kapa) shr 4;
    j:=pred(j)+ram and 3 or not even;
  end;
  j:=ReadTimer;
  faktor:=ergeb div j;
 {Ausgabe in Prozent}
  write(faktor,'%      CPU: ');
  if not AT then begin
    loop:=faktor div 4;
    StartTimer;
    for i:=1 to loop do begin
      even:=even; even:=even;
      even:=even; even:=even;
    end;
    z1:=ReadTimer;
    StartTimer;
    for i:=1 to loop do begin
      odd:=odd; odd:=odd;
      odd:=odd; odd:=odd;
    end;
    z2:=ReadTimer;
 {8-Bit-XT oder 16-Bit-XT?}
    if z1+10<z2 then bus:=16
                else bus:=8;
    loop:=faktor div 10;
    j:=23456;
    StartTimer;
    for i:=1 to loop do
      ergeb:=j div i div i div i;
    z1:=ReadTimer;
    j:=72;
    StartTimer;
    for i:=1 to loop do ergeb:=j*i*i*i;
    z2:=ReadTimer;
 {Division gegenber Multiplikation}
    if bus=8 then
      if z1>z2+50 then write('8088')
      else begin
        write('NEC V20');
        nec:=true;
      end;
    if bus=16 then
      if z1>z2+50 then write('8086')
      else begin
        write('NEC V30');
        nec:=true;
      end;
  end
  else begin
 { AT }
    loop:=faktor div 4;
    StartTimer;
    for i:=0 to loop do begin
      odd:=odd; odd:=odd;
      odd:=odd; odd:=odd;
    end;
    z1:=ReadTimer;
    StartTimer;
    for i:=0 to loop do begin
      garp:=garp; garp:=garp;
      garp:=garp; garp:=garp;
    end;
    z2:=ReadTimer;
 {16- oder 32-Bit-AT?}
    if z1+9<z2 then begin
      I386:=true;
      BUS32:=true;
      write('80386');
    end
    else begin
 {80286 oder 80386SX?}
      StartTimer;
      for i:=0 to faktor do
        j:=((i shl 8) shr 8) shl 8;
      z1:=ReadTimer-NullWert;
      StartTimer;
 {Beim 386 ist die Zeit fr Shift-
  Operationen von Bits unabhnig von
  der Anzahl der Bits               }
      for i:=0 to faktor do
        j:=((i shl 2) shr 2) shl 2;
      z2:=ReadTimer-NullWert;
      if z1>z2+40 then write('80286')
      else begin
        write('80386SX');
        I386:=true;
      end;
    end;
  end;
  if AT then    if I386 then AAMtime:=17
                        else AAMtime:=16;
  if not AT then if NEC then AAMtime:=15
                        else AAMtime:=77;
  for i:=0 to 3000 do
    memw[PuffSeg:i shl 1]:=$0AD4;
 {Puffer mit D40Ahex fllen}
  mem[PuffSeg:i*2+2]:=$CF;  {IRET ans Ende}
  StartTimer;
  intr(Int_Nr,regs);
 {Die 3001 AAMs ausfhren}
  z1:=ReadTimer-NullWert;
 {Reine Laufzeit bestimmen}
  takt:=1;
  takt:=AAMtime*100000 div
        (takt*z1*zykl div 3001);
 {Takt * 100}
  write(', ',takt div 100,'.',
        takt mod 100,' MHz');
  if bus=8 then begin
 {Bestimmung von WAITs}
    for i:=0 to 3000 do
      memw[PuffSeg:i shl 1]:=$9090;
    mem[puffseg:6001]:=$CF;
    starttimer;
 {6000 NOPs ausfhren}
    intr(Int_Nr,regs);
    z1:=readtimer-nullwert;
    kapa:=1;
    kapa:=kapa*z1*zykl div 6001*takt div
          100000 -4;
    writeln(', ',kapa,' Waitstate(s)');
  end
  else begin
 {16 Bit}
 {MOV AX,0000 im Vergleich zu MOV AX,0003
  Anhand der Differenz lassen sich die
  Waitstates erkennen                    }
    for i:=0 to 6000 do begin
      mem[puffseg:i*3]  :=$A1;
      mem[puffseg:i*3+1]:=$00;
      mem[puffseg:i*3+2]:=$00;
    end;
    mem[puffseg:i*3+3]:=$CF;
    starttimer;
    intr(Int_Nr,regs);
    z1:=readtimer-nullwert;
 {Zeit fr MOV AX,0000}
    for i:=0 to 6000 do
      mem[puffseg:i*3+1]:=$03;
    starttimer;
    intr(Int_Nr,regs);
    z2:=readtimer-nullwert;
 {Zeit fr MOV AX,0003}
    kapa:=1;
    kapa:=kapa*(z2-z1)*zykl*takt div
          6001 div 100000 -buszyklus;
    if BUS32 then writeln
    else writeln(', ',kapa,' Waitstate(s)');
  end;
 {Keine Waitstates-Bestimmung bei 80386
  (Da wird sich sowieso keiner einig!) }
end;

 {===== MAIN =====}

begin
  BUS16:=false;
  cache:=false;
 {Kein Cache installiert}
  PuffSeg:=(ram-30000)*64;
 {Ca. 28 KByte vor RAM-Ende}
  kontrol:=$43;
  tport :=$40+timer;
 {Startwerte fr Kurzzeitmessung}
  tstop :=timer shl 6;
  tstart:=$34+tstop;
  if timer=2 then
    port[$61]:=port[$61] or 1;
  TestVideoSpeed;
 {Werte fr Videogeschw. holen}
  writeln(ver);
  writeln;
  write('Dieser Rechner ist ein.....: ');
  AT:=false;
  if (ID=252) or (ID=248) then AT:=true;
  case ID of
    $ff:write('PC');
    $fe:if PS2=$9FC0 then
          writeln('PS/2 Model 30')
        else writeln('PC/XT');
    $fc:if PS2=$9FC0 then
          writeln('PS/2 Model 50/60')
        else writeln('AT');
    $f8:if PS2=$9FC0 then
          writeln('PS/2 Model 70/80')
        else writeln('AT 386');
    else begin
      writeln; writeln;
      writeln('Der Typ dieses Rechners '+
              'kann nicht identifiziert '+
              'werden. Im folgenden');
      writeln('wird davon ausgegangen, '+
              'da es sich um ein AT-'+
              'Modell handelt.');
      writeln('Bitte melden Sie diese '+
              'Zahl und das Computer'+
              'modell an den Autor: ',ID);
      writeln;
      AT:=true;
    end;
  end;
  write('BIOS vom ');
  for i:=0 to 7 do
    write(chr(mem[$f000:$fff5+i]));
  write('..........: ');
  BIOSID;
  write('Relative Geschw. zum IBM-PC: ');
  TestCPU;
  write('BIOS-Erweit. gefunden bei..: ');
  Search;
  write('Arbeitsspeichergre.......: ',
        ram,' KByte');
  writeln(', davon sind belegt: ',
          prefixseg div 64,' KByte');
  if AT then begin
    regs.ah:=136;
    intr(21,regs);
    writeln('Extended Memory............: ',
            regs.ax,' KByte frei');
  end;
  TestEMS;
  VGA:=false; EGA:=false;
 {Teste auf VGA}
  regs.ax:=$1B00;
  regs.es:=PuffSeg;
  regs.bx:=0;
  intr(16,regs);
  write('Installierte Grafikkarte...: ');
  if regs.al=$1B then VGA:=true
  else begin
 {Teste auf EGA}
     regs.ah:=18;
     regs.bl:=16;
     regs.cx:=0;
     intr(16,regs);
     if regs.cx>0 then EGA:=true;
  end;
  if EGA then write('EGA mit ');
  if VGA then write('VGA mit ');
  if AT and (EGA or VGA) then TestEGABus;
  if (EGA or VGA) then begin
    case (VideoInfo and 112) of
      112,16: write('512');
           0: write('64');
          32: write('128');
          64: write('192');
       96,48: write('256');
    end;
    write(' KByte und ');
    if (VideoInfo and 2)=2 then
      write('Monochrom')
    else write('Farb');
    write('monitor');
  end;
  if not (EGA or VGA) then
    if VideoMode=7 then begin
      testherc:=12345;
      if testherc=12345 then
        write('Hercules')
      else write('MDA');
    end
    else write('CGA');
  writeln;
  write('VideoRAM-Durchsatz.........: ',
         VideoDurchS,' KByte/s');
  scroll:=scroll div 100*zykl div 1000;
  write(', Scroll: ',scroll div 10,
        ',',scroll mod 10,' ms');
  if not BUS16 then
     write(', ',VideoWaits*takt
           div 4000 *zykl div 100000 -4,
           ' VideoWaits');
  writeln(#13#10,
          'Zeichenausgabe BIOS, DOS...: ',
          zyklinv div printB,' Byte/s, ',
          zyklinv div printD,' Byte/s');
  write  ('Momentaner Videomodus......: ',
          VideoMode,', ');
  case VideoMode of
    0: writeln('40*25 Zeichen, S/W');
    1: writeln('40*25 Zeichen, farbig');
    2: writeln('80*25 Zeichen, S/W');
    3: writeln('80*25 Zeichen, farbig');
    4: writeln('320*200 Punkte Grafik, '+
               '4 Farben');
    5: writeln('320*200 Punkte Grafik, '+
               'S/W');
    6: writeln('640*200 Punkte Grafik, '+
               '2 Farben');
    7: writeln('80*25 Zeichen im '+
               'Monochrom-Modus');
  end;
  regs.ah:=48; msdos(regs);
  writeln('DOS-Version................: ',
          regs.al,'.',regs.ah);
  writeln('Mathematischer Coprozessor.: ',
          x[(konfig shr 1) and 1]);
  if not AT then
  writeln('Gameadapter vorhanden......: ',
          x[(konfig shr 12) and 1]);
  writeln('Anzahl Diskettenlaufwerke..: ',
          (konfig shr 6) and 3+1);
  writeln('Serielle, parallele Ports..: ',
          (konfig shr 9) and 7,', ',
          (konfig shr 14) and 3);
  i:=-1; drive:=-1;
  if AT and (PS2<>$9FC0) then
  writeln('Kombi-Controller vorhanden.: ',
          x[(kombi and 1)]);
  repeat
    inc(i);
    regs.ah:=8;
    regs.dl:=$80+i;
    intr(19,regs);
    if regs.ah=0 then begin
       inc(drive); platte:=regs.dl;
       ax:=(regs.cl and 192) shl 2;
       sektoren:=regs.cl and 63;
       kapa:=(regs.ch+ax+1)*sektoren;
       kapa:=kapa*(regs.dh+1) div 195;
 {10/512}
       write('Daten fr Festplatte ',
             drive+1,' ....: ',kapa div 10,
             ',',kapa mod 10,' MByte, ');
       write(regs.dh+1,' Kpfe, ',
             regs.ch+ax+1,' Zylinder, ');
       writeln(sektoren,' Sekt/Zyl');
       InterLeave;
       Access(regs.ch+ax+1);
       if (regs.dl=1) or (platte=1) then
         i:=2;
    end;
  until (i=2);
  if cache then
    writeln('Ein Festplatten-Cache ist '+
            'installiert! Interleave und '+
            'Durchsatz stimmen nicht!');
end.
